using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration.Install;

/* 
   | Copyright 2007                |
   | Benjamin Day                  |
   | Benjamin Day Consulting, Inc. |
   | http://www.benday.com         |
   | http://blog.benday.com        |
    */

namespace Com.Benday.InstallerActions
{
	[RunInstaller(true)]
	public partial class InstallerEntryPoint : Installer
	{
		public InstallerEntryPoint()
		{
			InitializeComponent();
		}

		public override void Install(System.Collections.IDictionary stateSaver)
		{
			string action = Context.Parameters["action"];

			if (action == "VirtualDirectorySecurity")
			{
				IISActiveDirectoryUtility.SetSecurity(Context.Parameters);
			}
			else if (action == "ConfigurationFiles")
            {
				new EditConfigurationFilesAction().Install(Context.Parameters);
            }
			else
			{
				throw new InvalidOperationException(String.Format("Invalid action ({0}).", action));
			}
		}
	}
}