using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;

/* 
   | Copyright 2007                |
   | Benjamin Day                  |
   | Benjamin Day Consulting, Inc. |
   | http://www.benday.com         |
   | http://blog.benday.com        |
    */

namespace Com.Benday.InstallerActions
{
	public abstract class XmlConfigurationParserBase
	{
		private XmlDocument m_doc;
		private XmlNamespaceManager m_mgr;
		private string m_path;

		public XmlConfigurationParserBase(string path)
		{
			if (path == null)
			{
				throw new ArgumentNullException("path", "Argument cannot be null.");
			}

			Path = path;
			Document = new XmlDocument();
			Document.Load(path);
			NamespaceManager = new XmlNamespaceManager(Document.NameTable);
		}

		public XmlNamespaceManager NamespaceManager
		{
			get
			{
				return m_mgr;
			}
			set
			{
				m_mgr = value;
			}
		}

		public string Path
		{
			get
			{
				return m_path;
			}
			set
			{
				m_path = value;
			}
		}
protected XmlDocument Document
		{
			get
			{
				return m_doc;
			}
			set
			{
				m_doc = value;
			}
		}
		public virtual void Save()
		{
			Document.Save(Path);
		}
	}
}
